import { DynamicModule, OnModuleDestroy } from '@nestjs/common';
import { ModuleMetadata } from '@nestjs/common/interfaces';
import { RedisPubSub } from 'graphql-redis-subscriptions-graphql16-ioredis5';
import Redis, { RedisOptions } from 'ioredis';
export interface IOModuleAsyncOptions extends Pick<ModuleMetadata, 'imports'> {
    useFactory: (...args: any[]) => Promise<RedisOptions> | RedisOptions;
    inject?: any[];
}
export declare class IOCoreModule implements OnModuleDestroy {
    private readonly redisClient;
    private readonly redisPubSub;
    constructor(redisClient: Redis, redisPubSub: RedisPubSub);
    onModuleDestroy(): Promise<void>;
    static registerRedis(options: IOModuleAsyncOptions): DynamicModule;
    static registerRedisPubSub(publisherOpts: IOModuleAsyncOptions, subscriberOpts: IOModuleAsyncOptions): DynamicModule;
}
//# sourceMappingURL=module.core.d.ts.map