"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var IOCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.IOCoreModule = void 0;
const common_1 = require("@nestjs/common");
const graphql_redis_subscriptions_graphql16_ioredis5_1 = require("graphql-redis-subscriptions-graphql16-ioredis5");
const ioredis_1 = require("ioredis");
const constants_1 = require("./constants");
const helpers_1 = require("./helpers");
let IOCoreModule = IOCoreModule_1 = class IOCoreModule {
    constructor(redisClient, redisPubSub) {
        this.redisClient = redisClient;
        this.redisPubSub = redisPubSub;
    }
    onModuleDestroy() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.redisClient) {
                this.redisClient.disconnect();
            }
            if (this.redisPubSub) {
                this.redisPubSub.getPublisher().disconnect();
                this.redisPubSub.getSubscriber().disconnect();
            }
        });
    }
    static registerRedis(options) {
        const configToken = 'redisClientConfigToken';
        const configProvider = Object.assign({ provide: configToken }, options);
        const redisProvider = {
            provide: constants_1.REDIS_CLIENT_TOKEN,
            useFactory: (config) => {
                return new ioredis_1.default(config);
            },
            inject: [configToken]
        };
        const providers = [configProvider, redisProvider];
        return {
            module: IOCoreModule_1,
            providers,
            exports: providers
        };
    }
    static registerRedisPubSub(publisherOpts, subscriberOpts) {
        const pubConfigProvider = Object.assign({ provide: constants_1.REDIS_PUB_CONFIG_TOKEN }, publisherOpts);
        const subConfigProvider = Object.assign({ provide: constants_1.REDIS_SUB_CONFIG_TOKEN }, subscriberOpts);
        const redisPubSubProvider = {
            provide: constants_1.REDIS_PUB_SUB_TOKEN,
            useFactory: (pubOpts, subOtps) => {
                return new graphql_redis_subscriptions_graphql16_ioredis5_1.RedisPubSub({
                    publisher: new ioredis_1.default(pubOpts),
                    subscriber: new ioredis_1.default(subOtps)
                });
            },
            inject: [constants_1.REDIS_PUB_CONFIG_TOKEN, constants_1.REDIS_SUB_CONFIG_TOKEN]
        };
        const providers = [pubConfigProvider, subConfigProvider, redisPubSubProvider];
        return {
            module: IOCoreModule_1,
            providers,
            exports: providers
        };
    }
};
IOCoreModule = IOCoreModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({}),
    __param(0, (0, common_1.Optional)()),
    __param(0, (0, helpers_1.InjectRedisClient)()),
    __param(1, (0, common_1.Optional)()),
    __param(1, (0, helpers_1.InjectRedisPubSub)()),
    __metadata("design:paramtypes", [ioredis_1.default,
        graphql_redis_subscriptions_graphql16_ioredis5_1.RedisPubSub])
], IOCoreModule);
exports.IOCoreModule = IOCoreModule;
//# sourceMappingURL=module.core.js.map